# Asterisk

Asterisk configuration files and scripts.

## Installing Asterisk

As of Debian 12 Bookworm, Debian no longer has packages for Asterisk :(.
[I'm currently using the packages built by Unit193](https://software.opensuse.org//download.html?project=home%3Aunit193%3Aasterisk&package=asterisk). Big thank you!

### Using this Configuration

Decide which configuration you want (see ./configs dir).

- start: Just enough to make Asterisk start.
- users: Users can connect on udp 63000 and call each other.
- wip: The current work-in-progress configuration.

As a sudo user (or root)..

```

# After installing Asterisk (See the above Unit193 link for instructions
# on how to add the repo).

apt install git asterisk

systemctl stop asterisk

cd /etc/asterisk/

# Before you run anything else below here make sure you're in the right path!
mkdir ../asterisk_backup

mv -v ./*.conf ../asterisk_backup

# !! Be sure to notice the space and dot at the end here.
git clone https://markc.net/mpmc/asterisk.git .
#                                            ↑↑

# Copy desired configuration.
cp -vR ./.configs/start/*.conf .

# Modify then run `fix_permissions.sh` to fix permissions.
bash ./fix_permissions.sh`
```

You should now make your own changes as needed. Once you're happy you
can then start Asterisk with your config in place. `systemctl start asterisk`.


## Thanks

With thanks to (in random order):

 - The Asterisk Project (and so-on) https://asterisk.org
 - Unit193 https://unit193.net
 - sacredheartsc https://www.sacredheartsc.com/blog/building-a-personal-voip-system/
 - Phillw https://phillw.net

## Notes

As the configuration comes from various sources (links in the thanks
section), my own reading of the asterisk documentation, and a lot of
trial and error. There is a chance I've made a mistake or the unexpected
may happen. The standard "use at your own risk applies"!

Some files are copied and just modifed from their original source.
Values I have changed/added will be prefixed with a line break
and a comment.

```

;) This comment is an example.
my_custom_option = foo

;) The below option is commented out.
;my_other_custom_option = bar

```

The semicolon and right bracket ;) used here is to make finding what I've changed/added easier.

Asterisk configuration files use the semicolon for comments and to default an option.
> **Be aware that commenting out an option doesn't always disable it**. Asterisk will just use the hardcoded default instead.

